import { Search } from '../search.mjs';

export class LinearSearch extends Search {
  /**
   * @param {*[]} array - array to search in
   * @param {*} element - element to search for in the array
   * @return {Number} - zero based index in the array if element is found, otherwise -1
   */
  search(array, element) {
    for (let i = 0; i < array.length; i++) {
      if (this.comparator.eq(array[i], element)) {
        return i;
      }
    }
    return -1;
  }

  /**
   * @param {*[]} array - array to search in
   * @param {*} element - element to search for in the array
   * @return {Number[]} - array with found indexes
   */
  searchAll(array, element) {
    return array.reduce((result, currentElement, index) => {
      if (this.comparator.eq(element, currentElement)) {
        result.push(index);
      }
      return result;
    }, []);
  }
}
