import { Sort } from '../sort.mjs';
import { Queue } from '../../../data-structures/index.mjs';

export class BitSort extends Sort {
  /**
   * @param {Number[]} originalArray
   * @return {Number[]} sortedArray
   */
  sort(originalArray = []) {
    const q0 = new Queue();
    const q1 = new Queue();
    const sortedArray = [...originalArray];
    const max = Math.max(...originalArray);
    const maxlen = Math.floor(Math.log2(max) + 1);

    for (let i = 0; i < maxlen; i++) {
      const modded = 10 ** (i + 1);
      const divided = 10 ** i;

      while (sortedArray.length) {
        const element = sortedArray.shift();
        const lsd = Math.floor((element % modded) / divided);
        if (lsd === 0) q0.enqueue(element);
        if (lsd === 1) q1.enqueue(element);
      }

      while (!q0.isEmpty()) {
        sortedArray.push(q0.dequeue());
      }

      while (!q1.isEmpty()) {
        sortedArray.push(q1.dequeue());
      }
    }

    return sortedArray;
  }
}

