import { Sort } from '../sort.mjs';

export class BubbleSort extends Sort {
  /**
   * stable
   * sort in place
   *
   * @param {*[]} array - array to sort
   * @return {*[]} array - sorted array
   */
  sort(array) {
    let swapped;
    const len = array.length;

    for (let i = 0; i < len; i++) {
      swapped = false;
      this.callbacks.visitingCallback(array[i]);

      for (let j = 0; j < len - i - 1; j++) {
        this.callbacks.visitingCallback(array[j]);

        //** Swap elements if they are in wrong order. **//
        if (this.comparator.gt(array[j], array[j + 1])) {
          [array[j], array[j + 1]] = [array[j + 1], array[j]];
          swapped = true;
        }
      }

      //** If there were no swaps then the array is already soted **//
      if (!swapped) return array;
    }

    return array;
  }
}
