import { Sort } from '../sort.mjs';

export class PositiveCountingSort extends Sort {
  /**
   * sort out-of-place
   *
   * @param {Number[]} originalArray - array of positive numbers
   * @return {Number[]} sortedArray
   */
  sort(originalArray = []) {
    if (!originalArray.length) return [];

    const min = Math.min(...originalArray);
    const max = Math.max(...originalArray);

    if (min < 0) throw new Error(`Array contains negative number ${min}`);

    const countArray = Array(max + 1).fill(0);

    for (let i = 0; i < originalArray.length; i++) {
      countArray[originalArray[i]]++;
    }

    const sortedArray = [];

    for (let i = 0; i < countArray.length; i++) {
      while (countArray[i]--) {
        sortedArray.push(i);
      }
    }

    return sortedArray;
  }
}
