import { Sort } from '../sort.mjs';

export class InsertionSort extends Sort {
  /**
   * stable
   * sort in place
   *
   * @param {*[]} array - array to sort
   * @return {*[]} array - sorted array
   */
  sort(array) {
    for (let i = 0; i < array.length; i++) {
      let idx = i;
      this.callbacks.visitingCallback(array[idx]);

      //** Check if current element is less than previous elements **//
      while (idx > 0 && this.comparator.lt(array[idx], array[idx - 1])) {
        this.callbacks.visitingCallback(array[idx - 1]);
        [array[idx], array[idx - 1]] = [array[idx - 1], array[idx]];
        idx--;
      }
    }
    return array;
  }
}
