import { Sort } from '../sort.mjs';

export class SelectionSort extends Sort {
  /**
   * in-place
   * not-stable
   *
   * @param {*[]} array - array to sort
   * @return {*[]} array - sorted array
   */
  sort(array) {
    const len = array.length;

    for (let i = 0; i < len; i++) {
      let minIndex = i;

      //** call visiting callback **//
      this.callbacks.visitingCallback(array[i]);

      //** Find minimum element in the rest of the array **//
      for (let j = i + 1; j < array.length; j++) {
        //** call visiting callback **//
        this.callbacks.visitingCallback(array[j]);

        if (this.comparator.lt(array[j], array[minIndex])) {
          minIndex = j;
        }
      }

      //** If new minimum element has been found then swap it with current i-th element **//
      if (minIndex !== i) {
        [array[i], array[minIndex]] = [array[minIndex], array[i]];
      }
    }

    return array;
  }
}
