import { Sort } from '../sort.mjs';

export class ShakerSort extends Sort {
  /**
   * stable
   * sort in place
   *
   * @param {*[]} array - array to sort
   * @return {*[]} array - sorted array
   */
  sort(array) {
    const len = array.length;
    let start = 0;
    let end = len - 1;
    let swapped = true;

    while (swapped) {

      //** Reset the flag, because it might be true from a previous iteration **//
      swapped = false;

      //** loop from left to right the same way as bubble sort **//
      for (let i = start; i < end; i++) {
        this.callbacks.visitingCallback(array[i]);

        if (this.comparator.gt(array[i], array[i + 1])) {
          [array[i], array[i + 1]] = [array[i + 1], array[i]];
          swapped = true;
        }
      }

      //** if there was no swap, array is sorted **//
      if (!swapped) break;

      //** otherwise reset the flag, so it can be used in the next stage **//
      swapped = false;

      //** move the end point back by one, because item at the end is in its right spot **//
      end = end - 1;

      //** do the comparison from right to left now **//
      for (let j = end - 1; j > start - 1; j--) {
        this.callbacks.visitingCallback(array[j]);

        if (this.comparator.gt(array[j], array[j + 1])) {
          [array[j], array[j + 1]] = [array[j + 1], array[j]];
          swapped = true;
        }
      }

      start = start + 1;
    }

    return array;
  }
}
