import { Heap } from './heap.mjs';

export class MaxHeap extends Heap {
  /**
   * Cheks if pair of heap elements is in correct order.
   * For MinHeap the first element must be always smaller or equal.
   * For MaxHeap the first element must be always bigger or equal.
   *
   * @param {*} firstElement
   * @param {*} secondElement
   * @return {Boolean}
   *
   */
  pairIsInCorrectOrder(firstElement, secondElement) {
    return this.compare.gte(firstElement, secondElement);
  }
}
